<?php

namespace App\Filament\Imports;

use App\Models\DeviceMaster;
use Filament\Actions\Imports\ImportColumn;
use Filament\Actions\Imports\Importer;
use Filament\Actions\Imports\Models\Import;

class DeviceMasterImporter extends Importer
{
    protected static ?string $model = DeviceMaster::class;

    public static function getColumns(): array
    {
        return [
            ImportColumn::make('plant')
                ->requiredMapping()
                ->exampleHeader('Plant Name')
                ->example('Ransar Industries-I')
                ->label('Plant Name')
                ->relationship(resolveUsing:'name')
                ->rules(['required']),
            ImportColumn::make('name')
                ->requiredMapping()
                ->exampleHeader('Device Name')
                ->label('Device Name')
                ->rules(['required']),
            ImportColumn::make('mac_address')
                ->requiredMapping()
                ->exampleHeader('MAC Address')
                ->example('00:1A:2B:3C:4D:5E')
                ->label('MAC Address')
                ->rules(['required', 'mac_address']),
            ImportColumn::make('ip_address')
                ->requiredMapping()
                ->exampleHeader('IP Address')
                ->label('IP Address')
                ->rules(['required', 'ip']),
            ImportColumn::make('created_by')
                ->requiredMapping()
                ->exampleHeader('Created By')
                ->example('Admin')
                ->label('Created By')
                ->rules(['required']),
        ];
    }

    public function resolveRecord(): ?DeviceMaster
    {
        // return DeviceMaster::firstOrNew([
        //     // Update existing records, matching them by `$this->data['column_name']`
        //     'email' => $this->data['email'],
        // ]);

        return new DeviceMaster();
    }

    public static function getCompletedNotificationBody(Import $import): string
    {
        $body = 'Your device master import has completed and ' . number_format($import->successful_rows) . ' ' . str('row')->plural($import->successful_rows) . ' imported.';

        if ($failedRowsCount = $import->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to import.';
        }

        return $body;
    }
}
